#ifndef __Adv_Player_H
#define __Adv_Player_H

#include "aconst.h"

//This contains the player's current state.
typedef struct player_
{
	//Player name.  If not needed, you can disable this line.
	char Name[16];
	//Contains the room # of exit if exit available, or
	//-1 if none.  Disable is you don't need it.
	unsigned char ExitRoom;
	//Player's inventory.
	unsigned char Inv[8];
	//State of the items the player's holding.
	//You may remove this if not needed.
	unsigned char InvState [8];
	//Player's score.
	unsigned Score;
	//Array of bits to determine which tasks are done.
	//Examples are below.
	unsigned char Tasks[4];
	//Inventories for each room.
	unsigned char RoomInv [NumRooms][8];
	//State of the items in each room.
	//You may remove this if not needed.
	unsigned char RoomInvState [NumRooms][8];
	//State of each room.
	unsigned char RoomState [NumRooms];
};
extern struct player_ Player;

/********************************************************************/
/* Task defines, return whether task is done.                       */

//These are from my Smir 3, 1 text adventure.  They are here as
//examples on how to write your own task conditions.
/*Call from Talnon at start of game answered*/
#define taskTalnonAnswered1	(Player.Tasks[0]&1)
/*Ransom letter at Talnon's read*/
#define taskRansomRead		(Player.Tasks[0]&2)
/*Search supplies bought*/
#define taskScannersBought	(Player.Tasks[0]&4)
/*Portal to Malin open*/
#define taskPortalToMalinOpen	(Player.Tasks[0]&8)

#endif

