#ifndef __AUXMEMAPPLE_H
#define __AUXMEMAPPLE_H

#include <stddef.h>

//----------------------------------------------------------------------
// Quick access:
//----------------------------------------------------------------------

/* Read value from Bank 1. */
unsigned char __fastcall__ aux_readbyte (void*);
unsigned int __fastcall__ aux_readword (void*);

/* Write value to Bank 1. */
void __fastcall__ aux_writebyte (void*, unsigned char);
void __fastcall__ aux_writeword (void*, unsigned int);

//----------------------------------------------------------------------
// Basic memory functions:
//----------------------------------------------------------------------
/* Copy a data block from Bank 0 to Bank 1 */
void __fastcall__ aux_memcpyto (void* dest, void* sour, unsigned len);
/* Copy a data block from Bank 1 to Bank 0 */
void __fastcall__ aux_memcpyfrom (void* dest, void* sour, unsigned len);
/* Copy a data block in Bank 1 */
void __fastcall__ aux_memcpyin (void* dest, void* sour, unsigned len);

/* Set file name and read/write banks for CBM file routines */
void __fastcall__ cbm_k_setbnk (unsigned char readbank, unsigned char namebank);

void* __fastcall__ aux_memset (void* s, int c, size_t count);
void __fastcall__ aux_bzero (void* s, size_t count);
//----------------------------------------------------------------------
// Bank 1 string operations:
//----------------------------------------------------------------------
int __fastcall__ aux_strlen (char* s);
char* __fastcall__ aux_strcpyin (char* dest, char* sour);
char* __fastcall__ aux_strcpyto (char* dest, char* sour);
char* __fastcall__ aux_strcpyfrom (char* dest, char* sour);
void __fastcall__ aux_print (const char* s);

//----------------------------------------------------------------------
//Load stubs:
//----------------------------------------------------------------------

//Loads data to aux RAM.
unsigned char loadauxro (char* filename);

//Loads a file to main memory at given buffer address.
unsigned char loadstub (char* filename, void* buffer);

//Save a buffer in Aux RAM to disk.
unsigned char saveauxro (char* filename, void* buffer, unsigned size);

void aux_init (void);

#endif
